# wxToolBar Class Reference
[Miscellaneous Windows]

`#include <wx/toolbar.h>`

Inheritance diagram for wxToolBar:
[legend]

## Detailed Description

A toolbar is a bar of buttons and/or other controls usually placed below the menu bar in a wxFrame.

You may create a toolbar that is managed by a frame calling wxFrame::CreateToolBar(). Under Pocket PC, you should always use this function for creating the toolbar to be managed by the frame, so that wxWidgets can use a combined menubar and toolbar. Where you manage your own toolbars, create wxToolBar as usual.

There are several different types of tools you can add to a toolbar. These types are controlled by the wxItemKind enumeration.

Note that many methods in wxToolBar such as wxToolBar::AddTool return a `wxToolBarToolBase*` object. This should be regarded as an opaque handle representing the newly added toolbar item, providing access to its id and position within the toolbar. Changes to the item's state should be made through calls to wxToolBar methods, for example wxToolBar::EnableTool. Calls to `wxToolBarToolBase` methods (undocumented by purpose) will not change the visible state of the item within the tool bar.

wxMSW note: Note that under wxMSW toolbar paints tools to reflect system-wide colours. If you use more than 16 colours in your tool bitmaps, you may wish to suppress this behaviour, otherwise system colours in your bitmaps will inadvertently be mapped to system colours. To do this, set the msw.remap system option before creating the toolbar:

        wxSystemOptions::SetOption("msw.remap", 0);

If you wish to use 32-bit images (which include an alpha channel for transparency) use:

        wxSystemOptions::SetOption("msw.remap", 2);

Then colour remapping is switched off, and a transparent background used. But only use this option under Windows XP with true colour:

        if (wxTheApp->GetComCtl32Version() >= 600 && ::wxDisplayDepth() >= 32)

## Styles

This class supports the following styles:

- wxTB_FLAT:
  Gives the toolbar a flat look (Windows and GTK only).
- wxTB_DOCKABLE:
  Makes the toolbar floatable and dockable (GTK only).
- wxTB_HORIZONTAL:
  Specifies horizontal layout (default).
- wxTB_VERTICAL:
  Specifies vertical layout.
- wxTB_TEXT:
  Shows the text in the toolbar buttons; by default only icons are shown.
- wxTB_NOICONS:
  Specifies no icons in the toolbar buttons; by default they are shown.
- wxTB_NODIVIDER:
  Specifies no divider (border) above the toolbar (Windows only)
- wxTB_NOALIGN:
  Specifies no alignment with the parent window (Windows only, not very useful).
- wxTB_HORZ_LAYOUT:
  Shows the text and the icons alongside, not vertically stacked (Windows and GTK 2 only). This style must be used with `wxTB_TEXT`.
- wxTB_HORZ_TEXT:
  Combination of `wxTB_HORZ_LAYOUT` and `wxTB_TEXT`.
- wxTB_NO_TOOLTIPS:
  Don't show the short help tooltips for the tools when the mouse hovers over them.
- wxTB_BOTTOM:
  Align the toolbar at the bottom of parent window.
- wxTB_RIGHT:
  Align the toolbar at the right side of parent window.

See also Window Styles. Note that the wxMSW native toolbar ignores `wxTB_NOICONS` style. Also, toggling the `wxTB_TEXT` works only if the style was initially on.

## Events emitted by this class

The following event handler macros redirect the events to member function handlers 'func' with prototypes like:

void handlerFuncName(wxCommandEvent& event)
Event macros for events emitted by this class:

- EVT_TOOL(id, func):
  Process a `wxEVT_COMMAND_TOOL_CLICKED` event (a synonym for `wxEVT_COMMAND_MENU_SELECTED`). Pass the id of the tool.
- EVT_MENU(id, func):
  The same as EVT_TOOL().
- EVT_TOOL_RANGE(id1, id2, func):
  Process a `wxEVT_COMMAND_TOOL_CLICKED` event for a range of identifiers. Pass the ids of the tools.
- EVT_MENU_RANGE(id1, id2, func):
  The same as EVT_TOOL_RANGE().
- EVT_TOOL_RCLICKED(id, func):
  Process a `wxEVT_COMMAND_TOOL_RCLICKED` event. Pass the id of the tool. (Not available on wxOSX.)
- EVT_TOOL_RCLICKED_RANGE(id1, id2, func):
  Process a `wxEVT_COMMAND_TOOL_RCLICKED` event for a range of ids. Pass the ids of the tools. (Not available on wxOSX.)
- EVT_TOOL_ENTER(id, func):
  Process a `wxEVT_COMMAND_TOOL_ENTER` event. Pass the id of the toolbar itself. The value of wxCommandEvent::GetSelection() is the tool id, or -1 if the mouse cursor has moved off a tool. (Not available on wxOSX.)
- EVT_TOOL_DROPDOWN(id, func):
  Process a `wxEVT_COMMAND_TOOL_DROPDOWN_CLICKED` event. If unhandled, displays the default dropdown menu set using wxToolBar::SetDropdownMenu().

The toolbar class emits menu commands in the same way that a frame menubar does, so you can use one EVT_MENU() macro for both a menu item and a toolbar button. The event handler functions take a wxCommandEvent argument. For most event macros, the identifier of the tool is passed, but for EVT_TOOL_ENTER() the toolbar window identifier is passed and the tool identifier is retrieved from the wxCommandEvent. This is because the identifier may be `wxID_ANY` when the mouse moves off a tool, and `wxID_ANY` is not allowed as an identifier in the event system.

##

Library: wxCore

Category: Miscellaneous Windows

See also:
  Toolbar Overview

## Public Member Functions
| wxToolBar ()
| Default constructor.
| wxToolBar (wxWindow *parent, wxWindowID id, const wxPoint &pos=wxDefaultPosition, const wxSize &size=wxDefaultSize, long style=wxTB_HORIZONTAL, const wxString &name=wxToolBarNameStr)
| Constructs a toolbar.
virtual | ~wxToolBar ()
| Toolbar destructor.
wxToolBarToolBase * | AddCheckTool (int toolId, const wxString &label, const wxBitmap &bitmap1, const wxBitmap &bmpDisabled=wxNullBitmap, const wxString &shortHelp=wxEmptyString, const wxString &longHelp=wxEmptyString, wxObject *clientData=NULL)
| Adds a new check (or toggle) tool to the toolbar.
virtual wxToolBarToolBase * | AddControl (wxControl *control, const wxString &label=wxEmptyString)
| Adds any control to the toolbar, typically e.g.
wxToolBarToolBase * | AddRadioTool (int toolId, const wxString &label, const wxBitmap &bitmap1, const wxBitmap &bmpDisabled=wxNullBitmap, const wxString &shortHelp=wxEmptyString, const wxString &longHelp=wxEmptyString, wxObject *clientData=NULL)
| Adds a new radio tool to the toolbar.
virtual wxToolBarToolBase * | AddSeparator ()
| Adds a separator for spacing groups of tools.
wxToolBarToolBase * | AddStretchableSpace ()
| Adds a stretchable space to the toolbar.
virtual void | ClearTools ()
| Deletes all the tools in the toolbar.
virtual bool | DeleteTool (int toolId)
| Removes the specified tool from the toolbar and deletes it.
virtual bool | DeleteToolByPos (size_t pos)
| This function behaves like DeleteTool() but it deletes the tool at the specified position and not the one with the given id.
virtual void | EnableTool (int toolId, bool enable)
| Enables or disables the tool.
wxToolBarToolBase * | FindById (int id) const
| Returns a pointer to the tool identified by id or NULL if no corresponding tool is found.
virtual wxControl * | FindControl (int id)
| Returns a pointer to the control identified by id or NULL if no corresponding control is found.
virtual wxToolBarToolBase * | FindToolForPosition (wxCoord x, wxCoord y) const
| Finds a tool for the given mouse position.
wxSize | GetMargins () const
| Returns the left/right and top/bottom margins, which are also used for inter-toolspacing.
virtual wxSize | GetToolBitmapSize () const
| Returns the size of bitmap that the toolbar expects to have.
const wxToolBarToolBase * | GetToolByPos (int pos) const
| Returns a pointer to the tool at ordinal position pos.
virtual wxObject * | GetToolClientData (int toolId) const
| Get any client data associated with the tool.
virtual bool | GetToolEnabled (int toolId) const
| Called to determine whether a tool is enabled (responds to user input).
virtual wxString | GetToolLongHelp (int toolId) const
| Returns the long help for the given tool.
virtual int | GetToolPacking () const
| Returns the value used for packing tools.
virtual int | GetToolPos (int toolId) const
| Returns the tool position in the toolbar, or `wxNOT_FOUND` if the tool is not found.
virtual int | GetToolSeparation () const
| Returns the default separator size.
virtual wxString | GetToolShortHelp (int toolId) const
| Returns the short help for the given tool.
virtual wxSize | GetToolSize () const
| Returns the size of a whole button, which is usually larger than a tool bitmap because of added 3D effects.
virtual bool | GetToolState (int toolId) const
| Gets the on/off state of a toggle tool.
size_t | GetToolsCount () const
| Returns the number of tools in the toolbar.
virtual wxToolBarToolBase * | InsertControl (size_t pos, wxControl *control, const wxString &label=wxEmptyString)
| Inserts the control into the toolbar at the given position.
virtual wxToolBarToolBase * | InsertSeparator (size_t pos)
| Inserts the separator into the toolbar at the given position.
wxToolBarToolBase * | InsertStretchableSpace (size_t pos)
| Inserts a stretchable space at the given position.
virtual bool | OnLeftClick (int toolId, bool toggleDown)
| Called when the user clicks on a tool with the left mouse button.
virtual void | OnMouseEnter (int toolId)
| This is called when the mouse cursor moves into a tool or out of the toolbar.
virtual void | OnRightClick (int toolId, long x, long y)
virtual bool | Realize ()
| This function should be called after you have added tools.
virtual wxToolBarToolBase * | RemoveTool (int id)
| Removes the given tool from the toolbar but doesn't delete it.
void | SetBitmapResource (int resourceId)
| Sets the bitmap resource identifier for specifying tool bitmaps as indices into a custom bitmap.
bool | SetDropdownMenu (int id, wxMenu *menu)
| Sets the dropdown menu for the tool given by its id.
virtual void | SetToolBitmapSize (const wxSize &size)
| Sets the default size of each tool bitmap.
virtual void | SetToolClientData (int id, wxObject *clientData)
| Sets the client data associated with the tool.
virtual void | SetToolDisabledBitmap (int id, const wxBitmap &bitmap)
| Sets the bitmap to be used by the tool with the given ID when the tool is in a disabled state.
virtual void | SetToolLongHelp (int toolId, const wxString &helpString)
| Sets the long help for the given tool.
virtual void | SetToolNormalBitmap (int id, const wxBitmap &bitmap)
| Sets the bitmap to be used by the tool with the given ID.
virtual void | SetToolPacking (int packing)
| Sets the value used for spacing tools.
virtual void | SetToolSeparation (int separation)
| Sets the default separator size.
virtual void | SetToolShortHelp (int toolId, const wxString &helpString)
| Sets the short help for the given tool.
virtual void | ToggleTool (int toolId, bool toggle)
| Toggles a tool on or off.
virtual wxToolBarToolBase * | AddTool (wxToolBarToolBase *tool)
| Adds a tool to the toolbar.
wxToolBarToolBase * | AddTool (int toolId, const wxString &label, const wxBitmap &bitmap, const wxString &shortHelp=wxEmptyString, wxItemKind kind=wxITEM_NORMAL)
| Adds a tool to the toolbar.
wxToolBarToolBase * | AddTool (int toolId, const wxString &label, const wxBitmap &bitmap, const wxBitmap &bmpDisabled=wxNullBitmap, wxItemKind kind=wxITEM_NORMAL, const wxString &shortHelpString=wxEmptyString, const wxString &longHelpString=wxEmptyString, wxObject *clientData=NULL)
| Adds a tool to the toolbar.
wxToolBarToolBase * | InsertTool (size_t pos, int toolId, const wxBitmap &bitmap1, const wxBitmap &bitmap2=wxNullBitmap, bool isToggle=false, wxObject *clientData=NULL, const wxString &shortHelpString=wxEmptyString, const wxString &longHelpString=wxEmptyString)
| Inserts the tool with the specified attributes into the toolbar at the given position.
wxToolBarToolBase * | InsertTool (size_t pos, wxToolBarToolBase *tool)
| Inserts the tool with the specified attributes into the toolbar at the given position.
virtual void | SetMargins (int x, int y)
| Set the values to be used as margins for the toolbar.
void | SetMargins (const wxSize &size)
| Set the margins for the toolbar.

List of all members.

## Constructor & Destructor Documentation

wxToolBar::wxToolBar | ( |  | ) |

Default constructor.

wxToolBar::wxToolBar | ( | wxWindow * | parent,
|  | wxWindowID | id,
|  | const wxPoint & | pos = `wxDefaultPosition`,
|  | const wxSize & | size = `wxDefaultSize`,
|  | long | style = `wxTB_HORIZONTAL`,
|  | const wxString & | name = `wxToolBarNameStr` |
| ) |  |  |

Constructs a toolbar.

Parameters:

  | parent | Pointer to a parent window.
  | id | Window identifier. If -1, will automatically create an identifier.
  | pos | Window position. wxDefaultPosition indicates that wxWidgets should generate a default position for the window. If using the wxWindow class directly, supply an actual position.
  | size | Window size. wxDefaultSize indicates that wxWidgets should generate a default size for the window.
  | style | Window style. See wxToolBar initial description for details.
  | name | Window name.

Remarks:
  After a toolbar is created, you use AddTool() and perhaps AddSeparator(), and then you must call Realize() to construct and display the toolbar tools.

virtual wxToolBar::~wxToolBar | ( |  | ) | `[virtual]`

Toolbar destructor.

## Member Function Documentation

wxToolBarToolBase* wxToolBar::AddCheckTool | ( | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bitmap1,
|  | const wxBitmap & | bmpDisabled = `wxNullBitmap`,
|  | const wxString & | shortHelp = `wxEmptyString`,
|  | const wxString & | longHelp = `wxEmptyString`,
|  | wxObject * | clientData = `NULL` |
| ) |  |  |

Adds a new check (or toggle) tool to the toolbar.

The parameters are the same as in AddTool().

See also:
  AddTool()

virtual wxToolBarToolBase* wxToolBar::AddControl | ( | wxControl * | control,
|  | const wxString & | label = `wxEmptyString` |
| ) |  |  | `[virtual]`

Adds any control to the toolbar, typically e.g.

a wxComboBox.

Parameters:

  | control | The control to be added.
  | label | Text to be displayed near the control.

Remarks:
  wxMSW: the label is only displayed if there is enough space available below the embedded control.

  wxMac: labels are only displayed if wxWidgets is built with `wxMAC_USE_NATIVE_TOOLBAR` set to 1

wxToolBarToolBase* wxToolBar::AddRadioTool | ( | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bitmap1,
|  | const wxBitmap & | bmpDisabled = `wxNullBitmap`,
|  | const wxString & | shortHelp = `wxEmptyString`,
|  | const wxString & | longHelp = `wxEmptyString`,
|  | wxObject * | clientData = `NULL` |
| ) |  |  |

Adds a new radio tool to the toolbar.

Consecutive radio tools form a radio group such that exactly one button in the group is pressed at any moment, in other words whenever a button in the group is pressed the previously pressed button is automatically released. You should avoid having the radio groups of only one element as it would be impossible for the user to use such button.

By default, the first button in the radio group is initially pressed, the others are not.

See also:
  AddTool()

virtual wxToolBarToolBase* wxToolBar::AddSeparator | ( |  | ) | `[virtual]`

Adds a separator for spacing groups of tools.

Notice that the separator uses the look appropriate for the current platform so it can be a vertical line (MSW, some versions of GTK) or just an empty space or something else.

See also:
  AddTool(), SetToolSeparation(), AddStretchableSpace()

wxToolBarToolBase* wxToolBar::AddStretchableSpace | ( |  | ) |

Adds a stretchable space to the toolbar.

Any space not taken up by the fixed items (all items except for stretchable spaces) is distributed in equal measure between the stretchable spaces in the toolbar. The most common use for this method is to add a single stretchable space before the items which should be right-aligned in the toolbar, but more exotic possibilities are possible, e.g. a stretchable space may be added in the beginning and the end of the toolbar to centre all toolbar items.

See also:
  AddTool(), AddSeparator(), InsertStretchableSpace()

Since:
  2.9.1

wxToolBarToolBase* wxToolBar::AddTool | ( | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bitmap,
|  | const wxBitmap & | bmpDisabled = `wxNullBitmap`,
|  | wxItemKind | kind = `wxITEM_NORMAL`,
|  | const wxString & | shortHelpString = `wxEmptyString`,
|  | const wxString & | longHelpString = `wxEmptyString`,
|  | wxObject * | clientData = `NULL` |
| ) |  |  |

Adds a tool to the toolbar.

Parameters:

  | toolId | An integer by which the tool may be identified in subsequent operations.
  | label | The string to be displayed with the tool.
  | bitmap | The primary tool bitmap.
  | bmpDisabled | The bitmap used when the tool is disabled. If it is equal to wxNullBitmap (default), the disabled bitmap is automatically generated by greying the normal one.
  | kind | May be wxITEM_NORMAL for a normal button (default), wxITEM_CHECK for a checkable tool (such tool stays pressed after it had been toggled) or wxITEM_RADIO for a checkable tool which makes part of a radio group of tools each of which is automatically unchecked whenever another button in the group is checked. wxITEM_DROPDOWN specifies that a drop-down menu button will appear next to the tool button (only GTK+ and MSW). Call SetDropdownMenu() afterwards.
  | shortHelpString | This string is used for the tools tooltip.
  | longHelpString | This string is shown in the statusbar (if any) of the parent frame when the mouse pointer is inside the tool.
  | clientData | An optional pointer to client data which can be retrieved later using GetToolClientData().

Remarks:
  After you have added tools to a toolbar, you must call Realize() in order to have the tools appear.

See also:
  AddSeparator(), AddCheckTool(), AddRadioTool(), InsertTool(), DeleteTool(), Realize(), SetDropdownMenu()

wxToolBarToolBase* wxToolBar::AddTool | ( | int | toolId,
|  | const wxString & | label,
|  | const wxBitmap & | bitmap,
|  | const wxString & | shortHelp = `wxEmptyString`,
|  | wxItemKind | kind = `wxITEM_NORMAL` |
| ) |  |  |

Adds a tool to the toolbar.

This most commonly used version has fewer parameters than the full version below which specifies the more rarely used button features.

Parameters:

  | toolId | An integer by which the tool may be identified in subsequent operations.
  | label | The string to be displayed with the tool.
  | bitmap | The primary tool bitmap.
  | shortHelp | This string is used for the tools tooltip.
  | kind | May be wxITEM_NORMAL for a normal button (default), wxITEM_CHECK for a checkable tool (such tool stays pressed after it had been toggled) or wxITEM_RADIO for a checkable tool which makes part of a radio group of tools each of which is automatically unchecked whenever another button in the group is checked. wxITEM_DROPDOWN specifies that a drop-down menu button will appear next to the tool button (only GTK+ and MSW). Call SetDropdownMenu() afterwards.

Remarks:
  After you have added tools to a toolbar, you must call Realize() in order to have the tools appear.

See also:
  AddSeparator(), AddCheckTool(), AddRadioTool(), InsertTool(), DeleteTool(), Realize(), SetDropdownMenu()

virtual wxToolBarToolBase* wxToolBar::AddTool | ( | wxToolBarToolBase * | tool | ) | `[virtual]`

Adds a tool to the toolbar.

Parameters:

  | tool | The tool to be added.

Remarks:
  After you have added tools to a toolbar, you must call Realize() in order to have the tools appear.

See also:
  AddSeparator(), AddCheckTool(), AddRadioTool(), InsertTool(), DeleteTool(), Realize(), SetDropdownMenu()

virtual void wxToolBar::ClearTools | ( |  | ) | `[virtual]`

Deletes all the tools in the toolbar.

virtual bool wxToolBar::DeleteTool | ( | int | toolId | ) | `[virtual]`

Removes the specified tool from the toolbar and deletes it.

If you don't want to delete the tool, but just to remove it from the toolbar (to possibly add it back later), you may use RemoveTool() instead.

Note:
  It is unnecessary to call Realize() for the change to take place, it will happen immediately.

Returns:
  true if the tool was deleted, false otherwise.

See also:
  DeleteToolByPos()

virtual bool wxToolBar::DeleteToolByPos | ( | size_t | pos | ) | `[virtual]`

This function behaves like DeleteTool() but it deletes the tool at the specified position and not the one with the given id.

virtual void wxToolBar::EnableTool | ( | int | toolId,
|  | bool | enable |
| ) |  |  | `[virtual]`

Enables or disables the tool.

Parameters:

  | toolId | ID of the tool to enable or disable, as passed to AddTool().
  | enable | If true, enables the tool, otherwise disables it.

Remarks:
  Some implementations will change the visible state of the tool to indicate that it is disabled.

See also:
  GetToolEnabled(), ToggleTool()

wxToolBarToolBase* wxToolBar::FindById | ( | int | id | ) | const

Returns a pointer to the tool identified by id or NULL if no corresponding tool is found.

virtual wxControl* wxToolBar::FindControl | ( | int | id | ) | `[virtual]`

Returns a pointer to the control identified by id or NULL if no corresponding control is found.

virtual wxToolBarToolBase* wxToolBar::FindToolForPosition | ( | wxCoord | x,
|  | wxCoord | y |
| ) |  |  | const`[virtual]`

Finds a tool for the given mouse position.

Parameters:

  | x | X position.
  | y | Y position.

Returns:
  A pointer to a tool if a tool is found, or NULL otherwise.

Remarks:
  Currently not implemented in wxGTK (always returns NULL there).

wxSize wxToolBar::GetMargins | ( |  | ) | const

Returns the left/right and top/bottom margins, which are also used for inter-toolspacing.

See also:
  SetMargins()

virtual wxSize wxToolBar::GetToolBitmapSize | ( |  | ) | const`[virtual]`

Returns the size of bitmap that the toolbar expects to have.

The default bitmap size is platform-dependent: for example, it is 16*15 for MSW and 24*24 for GTK. This size does not necessarily indicate the best size to use for the toolbars on the given platform, for this you should use `wxArtProvider::GetNativeSizeHint(wxART_TOOLBAR)` but in any case, as the bitmap size is deduced automatically from the size of the bitmaps associated with the tools added to the toolbar, it is usually unnecessary to call SetToolBitmapSize() explicitly.

Remarks:
  Note that this is the size of the bitmap you pass to AddTool(), and not the eventual size of the tool button.

See also:
  SetToolBitmapSize(), GetToolSize()

const wxToolBarToolBase* wxToolBar::GetToolByPos | ( | int | pos | ) | const

Returns a pointer to the tool at ordinal position pos.

Don't confuse this with FindToolForPosition().

Since:
  2.9.1

See also:
  GetToolsCount()

virtual wxObject* wxToolBar::GetToolClientData | ( | int | toolId | ) | const`[virtual]`

Get any client data associated with the tool.

Parameters:

  | toolId | ID of the tool in question, as passed to AddTool().

Returns:
  Client data, or NULL if there is none.

virtual bool wxToolBar::GetToolEnabled | ( | int | toolId | ) | const`[virtual]`

Called to determine whether a tool is enabled (responds to user input).

Parameters:

  | toolId | ID of the tool in question, as passed to AddTool().

Returns:
  true if the tool is enabled, false otherwise.

See also:
  EnableTool()

virtual wxString wxToolBar::GetToolLongHelp | ( | int | toolId | ) | const`[virtual]`

Returns the long help for the given tool.

Parameters:

  | toolId | ID of the tool in question, as passed to AddTool().

See also:
  SetToolLongHelp(), SetToolShortHelp()

virtual int wxToolBar::GetToolPacking | ( |  | ) | const`[virtual]`

Returns the value used for packing tools.

See also:
  SetToolPacking()

virtual int wxToolBar::GetToolPos | ( | int | toolId | ) | const`[virtual]`

Returns the tool position in the toolbar, or `wxNOT_FOUND` if the tool is not found.

Parameters:

  | toolId | ID of the tool in question, as passed to AddTool().

size_t wxToolBar::GetToolsCount | ( |  | ) | const

Returns the number of tools in the toolbar.

virtual int wxToolBar::GetToolSeparation | ( |  | ) | const`[virtual]`

Returns the default separator size.

See also:
  SetToolSeparation()

virtual wxString wxToolBar::GetToolShortHelp | ( | int | toolId | ) | const`[virtual]`

Returns the short help for the given tool.

Parameters:

  | toolId | ID of the tool in question, as passed to AddTool().

See also:
  GetToolLongHelp(), SetToolShortHelp()

virtual wxSize wxToolBar::GetToolSize | ( |  | ) | const`[virtual]`

Returns the size of a whole button, which is usually larger than a tool bitmap because of added 3D effects.

See also:
  SetToolBitmapSize(), GetToolBitmapSize()

virtual bool wxToolBar::GetToolState | ( | int | toolId | ) | const`[virtual]`

Gets the on/off state of a toggle tool.

Parameters:

  | toolId | ID of the tool in question, as passed to AddTool().

Returns:
  true if the tool is toggled on, false otherwise.

See also:
  ToggleTool()

virtual wxToolBarToolBase* wxToolBar::InsertControl | ( | size_t | pos,
|  | wxControl * | control,
|  | const wxString & | label = `wxEmptyString` |
| ) |  |  | `[virtual]`

Inserts the control into the toolbar at the given position.

You must call Realize() for the change to take place.

See also:
  AddControl(), InsertTool()

virtual wxToolBarToolBase* wxToolBar::InsertSeparator | ( | size_t | pos | ) | `[virtual]`

Inserts the separator into the toolbar at the given position.

You must call Realize() for the change to take place.

See also:
  AddSeparator(), InsertTool()

wxToolBarToolBase* wxToolBar::InsertStretchableSpace | ( | size_t | pos | ) |

Inserts a stretchable space at the given position.

See AddStretchableSpace() for details about stretchable spaces.

See also:
  InsertTool(), InsertSeparator()

Since:
  2.9.1

wxToolBarToolBase* wxToolBar::InsertTool | ( | size_t | pos,
|  | wxToolBarToolBase * | tool |
| ) |  |  |

Inserts the tool with the specified attributes into the toolbar at the given position.

You must call Realize() for the change to take place.

See also:
  AddTool(), InsertControl(), InsertSeparator()

Returns:
  The newly inserted tool or NULL on failure. Notice that with the overload taking tool parameter the caller is responsible for deleting the tool in the latter case.

wxToolBarToolBase* wxToolBar::InsertTool | ( | size_t | pos,
|  | int | toolId,
|  | const wxBitmap & | bitmap1,
|  | const wxBitmap & | bitmap2 = `wxNullBitmap`,
|  | bool | isToggle = `false`,
|  | wxObject * | clientData = `NULL`,
|  | const wxString & | shortHelpString = `wxEmptyString`,
|  | const wxString & | longHelpString = `wxEmptyString` |
| ) |  |  |

Inserts the tool with the specified attributes into the toolbar at the given position.

You must call Realize() for the change to take place.

See also:
  AddTool(), InsertControl(), InsertSeparator()

Returns:
  The newly inserted tool or NULL on failure. Notice that with the overload taking tool parameter the caller is responsible for deleting the tool in the latter case.

virtual bool wxToolBar::OnLeftClick | ( | int | toolId,
|  | bool | toggleDown |
| ) |  |  | `[virtual]`

Called when the user clicks on a tool with the left mouse button.

This is the old way of detecting tool clicks; although it will still work, you should use the EVT_MENU() or EVT_TOOL() macro instead.

Parameters:

  | toolId | The identifier passed to AddTool().
  | toggleDown | true if the tool is a toggle and the toggle is down, otherwise is false.

Returns:
  If the tool is a toggle and this function returns false, the toggle state (internal and visual) will not be changed. This provides a way of specifying that toggle operations are not permitted in some circumstances.

See also:
  OnMouseEnter(), OnRightClick()

virtual void wxToolBar::OnMouseEnter | ( | int | toolId | ) | `[virtual]`

This is called when the mouse cursor moves into a tool or out of the toolbar.

This is the old way of detecting mouse enter events; although it will still work, you should use the EVT_TOOL_ENTER() macro instead.

Parameters:

  | toolId | Greater than -1 if the mouse cursor has moved into the tool, or -1 if the mouse cursor has moved. The programmer can override this to provide extra information about the tool, such as a short description on the status line.

Remarks:
  With some derived toolbar classes, if the mouse moves quickly out of the toolbar, wxWidgets may not be able to detect it. Therefore this function may not always be called when expected.

virtual void wxToolBar::OnRightClick | ( | int | toolId,
|  | long | x,
|  | long | y |
| ) |  |  | `[virtual]`

Deprecated:
  This is the old way of detecting tool right clicks; although it will still work, you should use the EVT_TOOL_RCLICKED() macro instead.

Called when the user clicks on a tool with the right mouse button. The programmer should override this function to detect right tool clicks.

Parameters:

  | toolId | The identifier passed to AddTool().
  | x | The x position of the mouse cursor.
  | y | The y position of the mouse cursor.

Remarks:
  A typical use of this member might be to pop up a menu.

See also:
  OnMouseEnter(), OnLeftClick()

virtual bool wxToolBar::Realize | ( |  | ) | `[virtual]`

This function should be called after you have added tools.

virtual wxToolBarToolBase* wxToolBar::RemoveTool | ( | int | id | ) | `[virtual]`

Removes the given tool from the toolbar but doesn't delete it.

This allows to insert/add this tool back to this (or another) toolbar later.

Note:
  It is unnecessary to call Realize() for the change to take place, it will happen immediately.

See also:
  DeleteTool()

void wxToolBar::SetBitmapResource | ( | int | resourceId | ) |

Sets the bitmap resource identifier for specifying tool bitmaps as indices into a custom bitmap.

Windows CE only.

bool wxToolBar::SetDropdownMenu | ( | int | id,
|  | wxMenu * | menu |
| ) |  |  |

Sets the dropdown menu for the tool given by its id.

The tool itself will delete the menu when it's no longer needed. Only supported under GTK+ und MSW.

If you define a EVT_TOOL_DROPDOWN() handler in your program, you must call wxEvent::Skip() from it or the menu won't be displayed.

void wxToolBar::SetMargins | ( | const wxSize & | size | ) |

Set the margins for the toolbar.

Parameters:

  | size | Margin size.

Remarks:
  This must be called before the tools are added if absolute positioning is to be used, and the default (zero-size) margins are to be overridden.

See also:
  GetMargins(), wxSize

virtual void wxToolBar::SetMargins | ( | int | x,
|  | int | y |
| ) |  |  | `[virtual]`

Set the values to be used as margins for the toolbar.

Parameters:

  | x | Left margin, right margin and inter-tool separation value.
  | y | Top margin, bottom margin and inter-tool separation value.

Remarks:
  This must be called before the tools are added if absolute positioning is to be used, and the default (zero-size) margins are to be overridden.

See also:
  GetMargins()

virtual void wxToolBar::SetToolBitmapSize | ( | const wxSize & | size | ) | `[virtual]`

Sets the default size of each tool bitmap.

The default bitmap size is 16 by 15 pixels.

Parameters:

  | size | The size of the bitmaps in the toolbar.

Remarks:
  This should be called to tell the toolbar what the tool bitmap size is. Call it before you add tools.

See also:
  GetToolBitmapSize(), GetToolSize()

virtual void wxToolBar::SetToolClientData | ( | int | id,
|  | wxObject * | clientData |
| ) |  |  | `[virtual]`

Sets the client data associated with the tool.

Parameters:

  | id | ID of the tool in question, as passed to AddTool().

virtual void wxToolBar::SetToolDisabledBitmap | ( | int | id,
|  | const wxBitmap & | bitmap |
| ) |  |  | `[virtual]`

Sets the bitmap to be used by the tool with the given ID when the tool is in a disabled state.

This can only be used on Button tools, not controls.

Parameters:

  | id | ID of the tool in question, as passed to AddTool().

Note:
  The native toolbar classes on the main platforms all synthesize the disabled bitmap from the normal bitmap, so this function will have no effect on those platforms.

virtual void wxToolBar::SetToolLongHelp | ( | int | toolId,
|  | const wxString & | helpString |
| ) |  |  | `[virtual]`

Sets the long help for the given tool.

Parameters:

  | toolId | ID of the tool in question, as passed to AddTool().
  | helpString | A string for the long help.

Remarks:
  You might use the long help for displaying the tool purpose on the status line.

See also:
  GetToolLongHelp(), SetToolShortHelp(),

virtual void wxToolBar::SetToolNormalBitmap | ( | int | id,
|  | const wxBitmap & | bitmap |
| ) |  |  | `[virtual]`

Sets the bitmap to be used by the tool with the given ID.

This can only be used on Button tools, not controls.

Parameters:

  | id | ID of the tool in question, as passed to AddTool().

virtual void wxToolBar::SetToolPacking | ( | int | packing | ) | `[virtual]`

Sets the value used for spacing tools.

The default value is 1.

Parameters:

  | packing | The value for packing.

Remarks:
  The packing is used for spacing in the vertical direction if the toolbar is horizontal, and for spacing in the horizontal direction if the toolbar is vertical.

See also:
  GetToolPacking()

virtual void wxToolBar::SetToolSeparation | ( | int | separation | ) | `[virtual]`

Sets the default separator size.

The default value is 5.

Parameters:

  | separation | The separator size.

See also:
  AddSeparator()

virtual void wxToolBar::SetToolShortHelp | ( | int | toolId,
|  | const wxString & | helpString |
| ) |  |  | `[virtual]`

Sets the short help for the given tool.

Parameters:

  | toolId | ID of the tool in question, as passed to AddTool().
  | helpString | The string for the short help.

Remarks:
  An application might use short help for identifying the tool purpose in a tooltip.

See also:
  GetToolShortHelp(), SetToolLongHelp()

virtual void wxToolBar::ToggleTool | ( | int | toolId,
|  | bool | toggle |
| ) |  |  | `[virtual]`

Toggles a tool on or off.

This does not cause any event to get emitted.

Parameters:

  | toolId | ID of the tool in question, as passed to AddTool().
  | toggle | If true, toggles the tool on, otherwise toggles it off.

Remarks:
  Only applies to a tool that has been specified as a toggle tool.

|  | [ top ]